package org.ten60.netkernel.security.endpoint;

import org.netkernel.layer0.nkf.INKFRequest;
import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.nkf.INKFRequestReadOnly;
import org.netkernel.layer0.nkf.INKFResponseReadOnly;
import org.netkernel.layer0.util.Utils;
import org.netkernel.module.standard.endpoint.TransparentOverlayImpl;

import org.ten60.netkernel.security.representation.GateKeeperPolicy;
import org.ten60.netkernel.security.representation.GateKeeperZone;

@Deprecated
public class GateKeeperOverlay extends TransparentOverlayImpl
{	
	public GateKeeperOverlay()
	{	declareThreadSafe();
		declareUnhandledExceptionsExpired(false);
	}
	
	public void onRequest(String aID, INKFRequestContext helper) throws Exception
	{	
		if (helper.getThisRequest().getVerb()==INKFRequestReadOnly.VERB_META)
		{	Utils.delegateRequestInto(getDelegateSpace(),helper);
		}
		else
		{	GateKeeperPolicy policy=(GateKeeperPolicy)helper.source("param:config", GateKeeperPolicy.class);
			String requestIdentifier = helper.getThisRequest().getIdentifier();
			GateKeeperZone z=policy.testURI(requestIdentifier);
			
			if(z!=null)
			{	//Validate
				INKFRequest req=helper.createRequest(z.getValidURI());
				req.injectRequestScope(getDelegateSpace());
				req.setRepresentationClass(Boolean.class);
				Boolean valid=(Boolean)helper.issueRequest(req);
				
				if(valid)
				{	Utils.delegateRequestInto(getDelegateSpace(),helper);
				}
				else
				{	req=helper.createRequest(z.getNotValidURI());
					req.injectRequestScope(getDelegateSpace());
					helper.createResponseFrom(helper.issueRequestForResponse(req));
				}
			}
			else
			{	throw helper.createFormattedException("EX_ACCESS_UNMATCHED", "MSG_ACCESS_UNMATCHED", null, null, requestIdentifier);
			}
		}
	}
}