package org.ten60.netkernel.security.representation;

import java.util.*;
import java.net.*;
import java.util.regex.*;

/**
 * GateKeeper Policy holds a policy for URI gatekeeper
 * @author  pjr
 */
public class GateKeeperPolicy
{
	ArrayList mZones;
	
	/** Creates a new instance of GateKeeperPolicy */
	public GateKeeperPolicy()
	{	mZones=new ArrayList(10);
	}
	
	public void addZone(GateKeeperZone aZone)
	{	mZones.add(aZone);
	}
	
	public GateKeeperZone testURI(String aURI)
	{	GateKeeperZone zone=null;
		Iterator zi=mZones.iterator();
		while(zi.hasNext())
		{	GateKeeperZone gkz=(GateKeeperZone)zi.next();
			if(gkz.matches(aURI))
			{	zone=gkz;
				break;
			}
		}
		return zone;
	}

}
